unit Unit1; // main

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  ComCtrls, StdCtrls,          Unit2, Unit3;

type
  { Tmain }
    Tmain = class(TForm)

    CBsettingsReady: TCheckBox;
    Egame_name: TEdit;
    Eplayer_name: TEdit;
    Irecruitment: TImage;
    Iupgrade: TImage;
    Ibuilding: TImage;
    Iadministration: TImage;
    Ispectator: TImage;
    Ig_field: TImage;
    Iplay: TImage;
    LstartDifficulty: TLabel;
    LBmaps: TListBox;
    Psettings: TPanel;
    Pg_m_navi: TPanel;
    Pg_field: TPanel;
    Pg_menu: TPanel;
    Pgame: TPanel;
    RBrecruitment: TRadioButton;
    RBupgrade: TRadioButton;
    RBbuilding: TRadioButton;
    RBadministration: TRadioButton;
    RBspectator: TRadioButton;
    RGnavi: TRadioGroup;
    TBviewpoint: TTrackBar;
    TBstartDifficulty: TTrackBar;

    procedure FormChangeBounds(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure IadministrationMouseDown(Sender: TObject);
    procedure IadministrationMouseEnter(Sender: TObject);
    procedure IadministrationMouseLeave(Sender: TObject);
    procedure IadministrationMouseUp(Sender: TObject);
    procedure IbuildingMouseDown(Sender: TObject);
    procedure IbuildingMouseEnter(Sender: TObject);
    procedure IbuildingMouseLeave(Sender: TObject);
    procedure IbuildingMouseUp(Sender: TObject);
    procedure IrecruitmentClick(Sender: TObject);
    procedure IrecruitmentMouseDown(Sender: TObject);
    procedure IrecruitmentMouseEnter(Sender: TObject);
    procedure IrecruitmentMouseLeave(Sender: TObject);
    procedure IrecruitmentMouseUp(Sender: TObject);
    procedure IspectatorMouseDown(Sender: TObject);
    procedure IspectatorMouseEnter(Sender: TObject);
    procedure IspectatorMouseLeave(Sender: TObject);
    procedure IspectatorMouseUp(Sender: TObject);
    procedure IupgradeMouseDown(Sender: TObject);
    procedure IupgradeMouseEnter(Sender: TObject);
    procedure IupgradeMouseLeave(Sender: TObject);
    procedure IupgradeMouseUp(Sender: TObject);
    procedure IplayClick(Sender: TObject);
    procedure IplayMouseDown(Sender: TObject);
    procedure IplayMouseEnter(Sender: TObject);
    procedure IplayMouseLeave(Sender: TObject);
    procedure IplayMouseUp(Sender: TObject);
    procedure LBmapsSelectionChange(Sender: TObject);
    procedure RGnaviChangeBounds(Sender: TObject);
    procedure TBstartDifficultyChange(Sender: TObject);
    procedure TBviewpointChange(Sender: TObject);
    procedure TBviewpointChangeBounds(Sender: TObject);
    procedure TBviewpointClick(Sender: TObject);

  private
    { private declarations }
  public
    { public declarations }
    procedure adjustMainPanel(panel: TPanel);
    procedure adjustGame;

    procedure startGame;
    procedure setStartValues(player,difficulty:integer);
    procedure resetSettings;
    procedure fadeAllNaviImages;
    procedure showPanel(panel:TPanel);
    procedure addAllAvailableMapsToList;

    procedure drawField(index:integer);

    function getVicinity(field:Tfield):String;
    function getVicinityBoni(troop:Ttroop;vicinity:String):Integer;
  end;

var
  Fmain:TForm;

implementation

{$R *.lfm}

{ Tmain }

procedure Tmain.FormCreate(Sender: TObject);
begin

  Tmain.constructData;

  // loading Timages
  Iplay.Picture.loadFromFile('data\img\Timage\play_f.png');

  startGame;
end;

procedure Tmain.IadministrationMouseDown(Sender: TObject);
begin
  fadeAllNaviImages;
  Iadministration.Picture.loadFromFile('data\img\Timage\administration_f.png');
end;

procedure Tmain.IadministrationMouseEnter(Sender: TObject);
begin
  Iadministration.Picture.loadFromFile('data\img\Timage\administration_h.png');
end;

procedure Tmain.IadministrationMouseLeave(Sender: TObject);
begin
  if RBadministration.Checked=True then Iadministration.Picture.loadFromFile('data\img\Timage\administration.png')
    else Iadministration.Picture.loadFromFile('data\img\Timage\administration_f.png');
end;

procedure Tmain.IadministrationMouseUp(Sender: TObject);
begin
  Iadministration.Picture.loadFromFile('data\img\Timage\administration_h.png');
  RBadministration.Checked:=True;
end;

procedure Tmain.IbuildingMouseDown(Sender: TObject);
begin
  fadeAllNaviImages;
  Ibuilding.Picture.loadFromFile('data\img\Timage\building_f.png');
end;

procedure Tmain.IbuildingMouseEnter(Sender: TObject);
begin
  Ibuilding.Picture.loadFromFile('data\img\Timage\building_h.png');
end;

procedure Tmain.IbuildingMouseLeave(Sender: TObject);
begin
  if RBbuilding.Checked=True then Ibuilding.Picture.loadFromFile('data\img\Timage\building.png')
    else Ibuilding.Picture.loadFromFile('data\img\Timage\building_f.png');
end;

procedure Tmain.IbuildingMouseUp(Sender: TObject);
begin
  Ibuilding.Picture.loadFromFile('data\img\Timage\building_h.png');
  RBbuilding.Checked:=True;
end;

procedure Tmain.IrecruitmentClick(Sender: TObject);
begin
end;

procedure Tmain.IrecruitmentMouseDown(Sender: TObject);
begin
  fadeAllNaviImages;
  Irecruitment.Picture.loadFromFile('data\img\Timage\recruitment_f.png');
end;

procedure Tmain.IrecruitmentMouseEnter(Sender: TObject);
begin
  Irecruitment.Picture.loadFromFile('data\img\Timage\recruitment_h.png');
end;

procedure Tmain.IrecruitmentMouseLeave(Sender: TObject);
begin
  if RBrecruitment.Checked=True then Irecruitment.Picture.loadFromFile('data\img\Timage\recruitment.png')
    else Irecruitment.Picture.loadFromFile('data\img\Timage\recruitment_f.png');
end;

procedure Tmain.IrecruitmentMouseUp(Sender: TObject);
begin
  Irecruitment.Picture.loadFromFile('data\img\Timage\recruitment_h.png');
  RBrecruitment.Checked:=True;
end;

procedure Tmain.IspectatorMouseDown(Sender: TObject);
begin
  fadeAllNaviImages;
  Ispectator.Picture.loadFromFile('data\img\Timage\spectator_f.png');
end;

procedure Tmain.IspectatorMouseEnter(Sender: TObject);
begin
  Ispectator.Picture.loadFromFile('data\img\Timage\spectator_h.png');
end;

procedure Tmain.IspectatorMouseLeave(Sender: TObject);
begin
  if RBspectator.Checked=True then Ispectator.Picture.loadFromFile('data\img\Timage\spectator.png')
    else Ispectator.Picture.loadFromFile('data\img\Timage\spectator_f.png');
end;

procedure Tmain.IspectatorMouseUp(Sender: TObject);
begin
  Ispectator.Picture.loadFromFile('data\img\Timage\spectator_h.png');
  RBspectator.Checked:=True;
end;

procedure Tmain.IupgradeMouseDown(Sender: TObject);
begin
  fadeAllNaviImages;
  Iupgrade.Picture.loadFromFile('data\img\Timage\upgrade_f.png');
end;

procedure Tmain.IupgradeMouseEnter(Sender: TObject);
begin
  Iupgrade.Picture.loadFromFile('data\img\Timage\upgrade_h.png');
end;

procedure Tmain.IupgradeMouseLeave(Sender: TObject);
begin
  if RBupgrade.Checked=True then Iupgrade.Picture.loadFromFile('data\img\Timage\upgrade.png')
    else Iupgrade.Picture.loadFromFile('data\img\Timage\upgrade_f.png');
end;

procedure Tmain.IupgradeMouseUp(Sender: TObject);
begin
  Iupgrade.Picture.loadFromFile('data\img\Timage\upgrade_h.png');
  RBupgrade.Checked:=True;
end;

procedure Tmain.IplayClick(Sender: TObject);
begin
  if CBsettingsReady.Checked=True then begin
    Game.Name:=Egame_name.Text;

    // loading map
    for i := 0 to LBmaps.Items.Count -1 do
    begin
      if LBmaps.Selected[i] then begin
        Game.Map:=MapList[i];
      end;
    end;

    setLength(Game.Player, 1);
    Game.Player[0].Name:=Eplayer_name.Text;
    setStartValues(0, TBstartDifficulty.Position);

    TBviewpoint.Max:=Game.Map.Map_Length;

    fadeAllNaviImages;
    RBadministration.Checked:=True;
    Iadministration.Picture.loadFromFile('data\img\Timage\administration.png');

    showPanel(Pgame);
    //adjustMainPanel(Pgame);
  end;
end;

procedure Tmain.IplayMouseDown(Sender: TObject);
begin
  Iplay.Picture.loadFromFile('data\img\Timage\play_f.png');
end;

procedure Tmain.IplayMouseEnter(Sender: TObject);
begin
  Iplay.Picture.loadFromFile('data\img\Timage\play_h.png');
end;

procedure Tmain.IplayMouseLeave(Sender: TObject);
begin
  Iplay.Picture.loadFromFile('data\img\Timage\play.png');
end;

procedure Tmain.IplayMouseUp(Sender: TObject);
begin
  Iplay.Picture.loadFromFile('data\img\Timage\play_h.png');
end;

procedure Tmain.LBmapsSelectionChange(Sender: TObject);
begin
  for i := 0 to LBmaps.Items.Count -1 do
  begin
    if LBmaps.Selected[i] then begin
      CBsettingsReady.Checked:=True;
      Iplay.Picture.loadFromFile('data\img\Timage\play.png');
    end;
  end;
end;

procedure Tmain.RGnaviChangeBounds(Sender: TObject);
begin
  fadeAllNaviImages;
  if RBrecruitment.Checked=True then begin
    Irecruitment.Picture.loadFromFile('data\img\Timage\recruitment.png');
  end else if RBupgrade.Checked=True then begin
    Iupgrade.Picture.loadFromFile('data\img\Timage\upgrade.png');
  end else if RBbuilding.Checked=True then begin
    Ibuilding.Picture.loadFromFile('data\img\Timage\building.png');
  end else if RBadministration.Checked=True then begin
    Iadministration.Picture.loadFromFile('data\img\Timage\administration.png');;
  end else if RBspectator.Checked=True then begin
    Ispectator.Picture.loadFromFile('data\img\Timage\spectator.png');
  end;
end;

procedure Tmain.TBstartDifficultyChange(Sender: TObject);
begin
  case TBstartDifficulty.Position of
    1: LstartDifficulty.Caption:='Start Difficulty : Lush';
    2: LstartDifficulty.Caption:='Start Difficulty : Good';
    3: LstartDifficulty.Caption:='Start Difficulty : Medium';
    4: LstartDifficulty.Caption:='Start Difficulty : Rare';
    5: LstartDifficulty.Caption:='Start Difficulty : Barely';
  end;
end;

procedure Tmain.TBviewpointChange(Sender: TObject);
begin
  adjustGame;
end;

procedure Tmain.TBviewpointChangeBounds(Sender: TObject);
begin
  adjustGame;
end;

procedure Tmain.TBviewpointClick(Sender: TObject);
begin
  adjustGame;
end;

procedure Tmain.FormChangeBounds(Sender: TObject);
begin

end;

procedure Tmain.adjustMainPanel(panel: TPanel);
begin
  panel.Width:=Fmain.Width;
  panel.Height:=Fmain.Height;
  panel.Left:=0;
  panel.Top:=0;
end;

procedure Tmain.adjustGame;
begin
  adjustMainPanel(Pgame);

  // adjust Pgame_game
  begin
  Pg_menu.Width:=Pg_menu.Height;
  Pg_menu.Height:=Pgame.Height;
  Pg_menu.Left:=0;
  Pg_menu.Top:=0;
    Pg_m_navi.Height:=Pgame.Height;
    Pg_m_navi.Width:=trunc((Pg_m_navi.Height-12)/5*1)+4;

    Irecruitment.Width:=trunc((Pg_m_navi.Height-12)/5*1);
    Irecruitment.Height:=Irecruitment.Width;
    Irecruitment.Left:=2;
    Irecruitment.Top:=2;

    Iupgrade.Width:=Irecruitment.Width;
    Iupgrade.Height:=Irecruitment.Width;
    Iupgrade.Left:=2;
    Iupgrade.Top:=trunc((Pg_m_navi.Height-12)/5*1)+4;

    Ibuilding.Width:=Irecruitment.Width;
    Ibuilding.Height:=Irecruitment.Width;
    Ibuilding.Left:=2;
    Ibuilding.Top:=trunc((Pg_m_navi.Height-12)/5*2)+6;

    Iadministration.Width:=Irecruitment.Width;
    Iadministration.Height:=Irecruitment.Width;
    Iadministration.Left:=2;
    Iadministration.Top:=trunc((Pg_m_navi.Height-12)/5*3)+8;

    Ispectator.Width:=Irecruitment.Width;
    Ispectator.Height:=Irecruitment.Width;
    Ispectator.Left:=2;
    Ispectator.Top:=trunc((Pg_m_navi.Height-12)/5*4)+10;

  Pg_field.Width:=Pgame.Width-Pg_menu.Width;
  Pg_field.Height:=Pgame.Height;
  Pg_field.Left:=Pg_menu.Width;
  Pg_field.Top:=0;
    TBviewpoint.Width:=Pgame.Width-Pg_menu.Width-2;
    TBviewpoint.Top:=Pg_field.Height-(TBviewpoint.Height+4);

    Ig_field.Height:=Pg_field.Height-(TBviewpoint.Height+8);
    Ig_field.Width:=Game.Map.Map_Length*Ig_field.Height;
    Ig_field.Top:=2;
    Ig_field.Left:=(Screen.Width - Fmain.Width) div 2;
  end;

  //

  // clear canvas
  With Ig_field.Canvas do begin
    Brush.Color:=clBlack;
    FillRect(0,0,Width,Height);
  end;

  // redraw canvas (all fields)
  for i:=0 to Game.Map.Map_Length-1 do begin
    drawField(i);
  end;
end;

procedure Tmain.startGame;
begin
  resetSettings;
  showPanel(Psettings);
end;

procedure Tmain.setStartValues(player, difficulty: integer);
begin
  Game.Player[player].Food:=difficulty*100;
  Game.Player[player].GemStone:=difficulty*100-100;
  Game.Player[player].Gold:=difficulty*150;
  Game.Player[player].Material:=difficulty*50;
end;

procedure Tmain.resetSettings;
begin
  Egame_name.Text:='game '+FormatDateTime('yy-mm-dd-hh-nn-ss', now);
  Eplayer_name.Text:='player name';
  addAllAvailableMapsToList;
end;

procedure Tmain.fadeAllNaviImages;
begin
  Irecruitment.Picture.loadFromFile('data\img\Timage\recruitment_f.png');
  Iupgrade.Picture.loadFromFile('data\img\Timage\upgrade_f.png');
  Ibuilding.Picture.loadFromFile('data\img\Timage\building_f.png');
  Iadministration.Picture.loadFromFile('data\img\Timage\administration_f.png');
  Ispectator.Picture.loadFromFile('data\img\Timage\spectator_f.png');
end;

procedure Tmain.showPanel(panel: TPanel);
begin
  Pgame.Visible:=False;
  Psettings.Visible:=False;

  panel.Top:=0;
  panel.Left:=0;
  panel.Visible:=True;

  Fmain.Width:=panel.Width;
  Fmain.Height:=panel.Height;
end;

procedure Tmain.addAllAvailableMapsToList;
begin
  LBmaps.Items.Clear;
  for i:=0 to length(MapList)-1 do begin
    LBmaps.Items.Add(MapList[i].Name);
  end;
end;

procedure Tmain.drawField(index: integer);
begin
  // loading image material
  case Game.Map.Field[index].Soil.Name of
    'Meadow'                           : Ig_field.Canvas.Brush.Color:=RGBToColor(163,173,121);
    'Hill'                             : Ig_field.Canvas.Brush.Color:=RGBToColor(182,170,133);
    'Acre'                             : Ig_field.Canvas.Brush.Color:=RGBToColor(155,201,33);
    'Forest'                           : Ig_field.Canvas.Brush.Color:=RGBToColor(71,119,47);
    'Fertile Forest'                   : Ig_field.Canvas.Brush.Color:=RGBToColor(0,147,0);
    'Stone Deposit'                    : Ig_field.Canvas.Brush.Color:=RGBToColor(145,138,122);
    'Gold Deposit'                     : Ig_field.Canvas.Brush.Color:=RGBToColor(255,240,124);
    'Gem Stone Deposit'                      : Ig_field.Canvas.Brush.Color:=RGBToColor(163,228,255);
    'Swamp'                            : Ig_field.Canvas.Brush.Color:=RGBToColor(133,114,168);
    'Desert'                           : Ig_field.Canvas.Brush.Color:=RGBToColor(211,182,60);
    'Waters'                           : Ig_field.Canvas.Brush.Color:=RGBToColor(71,149,193);
  //else begin
  //    showMessage('ERROR : unknown Soil.Name in drawField('+intToStr(index)+') _ Intended Soil : '+Game.Map.Field[index].Soil.Name);
  //    exit;
  //  end;
  end;

  // placing image
  Ig_field.Canvas.FillRect(index*Ig_field.Height,0,index*Ig_field.Height+Ig_field.Height,Ig_field.Height);

  //Bmp:=TBitmap.Create;
  //Bmp.Height:=Ig_field.Height;
  //Bmp.Width:=Ig_field.Width;
  //
  //Bmp.Canvas.Brush.Color:=clBlack;
  //Bmp.Canvas.FillRect(0,0,Ig_field.Width,Ig_field.Height);
  //Ig_field.Canvas.Draw(0,0,Bmp);
  //
  //Bmp.Canvas.Brush.Color:=clGreen;
  //Bmp.Canvas.FillRect(Rect(0,0,Ig_field.Height,Ig_field.Height));
  //Ig_field.Canvas.Draw(0,0,Bmp);
end;

function Tmain.getVicinity(field: Tfield): String;
begin
  result:=field.Soil.Name;
end;

function Tmain.getVicinityBoni(troop: Ttroop; vicinity: String): Integer;
begin
  if troop.VicinityAdaption.Vicinity=vicinity then result:=troop.VicinityAdaption.Ammount else result:=0;
end;

end.
